## cctbx 2022.9+ds2+~3.11.2+ds1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20 FATAL_ERROR)

project(dxtbx LANGUAGES C CXX)

# Add the included modules
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")

# General cmake environment configuration
include(SetDefaultBuildRelWithDebInfo) # Default builds to release with debug info
include(AlwaysColourCompilation) # Always show coloured compiler output
set(CMAKE_EXPORT_COMPILE_COMMANDS ON) # Generate compile_commands.json
set(CMAKE_CXX_STANDARD 11)

find_package(Python REQUIRED COMPONENTS Interpreter Development)
find_package(CCTBX COMPONENTS scitbx cctbx REQUIRED)
find_package(pybind11 REQUIRED)
find_package(CBFlib)

set(HDF5_USE_STATIC_LIBRARIES OFF)
find_package(HDF5 REQUIRED)
if(WIN32)
    # This is required on windows to declare symbols as external
    target_compile_definitions(hdf5::hdf5 INTERFACE H5_BUILT_AS_DYNAMIC_LIB)
endif()

# Find the boost::python library for this version of python
set(Boost_USE_STATIC_LIBS OFF) # This is the default everywhere except Windows
find_package(Boost COMPONENTS "python${Python_VERSION_MAJOR}${Python_VERSION_MINOR}" REQUIRED)


# Create Boost::python alias so we don't need to carry the python version around
if(NOT TARGET Boost::python )
    message("Adding Boost::python target")
    add_library(Boost::python INTERFACE IMPORTED)
    set_target_properties(Boost::python PROPERTIES
        INTERFACE_LINK_LIBRARIES  "python${Python_VERSION_MAJOR}${Python_VERSION_MINOR}" )
endif()


# Put the libraries into lib/ so that we can run this in-place in a TBX install
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY  "${CMAKE_BINARY_DIR}/lib")

add_subdirectory(src/dxtbx)

=== dox.sphinx/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = ../bin/cctbx.python $(shell which sphinx-build)
PAPER         = a4
BUILDDIR      = _build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes coverage linkcheck doctest

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  coverage   to make an overview of all undocumented items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/cctbx.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/cctbx.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/cctbx"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/cctbx"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	make -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

coverage:
	$(SPHINXBUILD) -b coverage $(ALLSPHINXOPTS) $(BUILDDIR)/coverage
	@echo
	@echo "The coverage files are in $(BUILDDIR)/coverage."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== src/dxtbx/CMakeLists.txt ===

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/..)

Python_add_library( dxtbx_ext
    MODULE
    boost_python/ext.cpp
    boost_python/compression.cc )
target_link_libraries(dxtbx_ext PRIVATE Boost::python CCTBX::scitbx)

Python_add_library( dxtbx_format_nexus_ext MODULE format/boost_python/nexus_ext.cc )
target_link_libraries( dxtbx_format_nexus_ext PRIVATE  Boost::python CCTBX::scitbx hdf5::hdf5 )

Python_add_library( dxtbx_imageset_ext MODULE boost_python/imageset_ext.cc )
target_link_libraries( dxtbx_imageset_ext PUBLIC Boost::python CCTBX::scitbx )

Python_add_library( dxtbx_format_image_ext
    MODULE
    format/boost_python/image_ext.cc
)
target_link_libraries( dxtbx_format_image_ext PUBLIC Boost::python CCTBX::scitbx HDF5::HDF5)
# If we have CBFlib available, use it
if (TARGET CBFlib::cbf)
    target_link_libraries( dxtbx_format_image_ext PRIVATE CBFlib::cbf )
    target_compile_definitions( dxtbx_format_image_ext PRIVATE BUILD_CBF )
    target_sources( dxtbx_format_image_ext PRIVATE format/boost_python/cbf_read_buffer.cpp )
endif()

Python_add_library( dxtbx_model_ext
    MODULE
    model/boost_python/beam.cc
    model/boost_python/spectrum.cc
    model/boost_python/goniometer.cc
    model/boost_python/kappa_goniometer.cc
    model/boost_python/multi_axis_goniometer.cc
    model/boost_python/panel.cc
    model/boost_python/detector.cc
    model/boost_python/scan.cc
    model/boost_python/scan_helpers.cc
    model/boost_python/crystal.cc
    model/boost_python/parallax_correction.cc
    model/boost_python/pixel_to_millimeter.cc
    model/boost_python/experiment.cc
    model/boost_python/experiment_list.cc
    model/boost_python/model_ext.cc )
target_link_libraries(
    dxtbx_model_ext
    PUBLIC
    Boost::python
    CCTBX::scitbx
)
if(WIN32)
    # Technically required on other platforms, but already loaded by time
    # of use in dxtbx, and a bug with -install_name settings for these
    # prevents direct linking from working on MacOS without fiddling
    # around with install_name_tool.
    target_link_libraries(
        dxtbx_model_ext
        PUBLIC
        CCTBX::scitbx::boost_python
        CCTBX::cctbx
    )
endif()

Python_add_library( dxtbx_masking_ext
    MODULE
    masking/boost_python/ext.cc )
target_link_libraries( dxtbx_masking_ext PUBLIC Boost::python CCTBX::scitbx )

pybind11_add_module(dxtbx_flumpy boost_python/flumpy.cc)
target_link_libraries(dxtbx_flumpy PUBLIC Boost::python CCTBX::scitbx )

include(CheckCXXCompilerFlag)
check_cxx_compiler_flag(-fvisibility=hidden HAS_VISIBILITY)
if(HAS_VISIBILITY)
    target_compile_options(dxtbx_flumpy PRIVATE -fvisibility=hidden)
endif()

install(
    TARGETS
        dxtbx_ext
        dxtbx_format_nexus_ext
        dxtbx_imageset_ext
        dxtbx_format_image_ext
        dxtbx_model_ext
        dxtbx_masking_ext
        dxtbx_flumpy
    DESTINATION "${Python_SITEARCH}"
)

=== debian/changelog ===
cctbx (2022.9+ds2+~3.11.2+ds1-1) unstable; urgency=medium

  * New upstream version 2022.9+ds2+~3.11.2+ds1
  * c/control:
    - B-D Added python3-mrcfile
    - B-D python3-requests
    - python"-cctbx depends on libcctbx-dev. the fable code
      requires the headers files.
  * dxtbx reactivate the FormatMRC module

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Thu, 06 Oct 2022 15:10:17 +0200

cctbx (2022.8+ds2+~3.11.1+ds1-2) unstable; urgency=medium

  * d/control: libcctbx-dev depends on libann-cctbx-dev
  * d/p/0017-cctbx-do-not-hide-sign-comparison.patch: to help arch port effort.
  * d/p/0017-dxtbx-fix-for-unsigned-char-arch.patch:
    try to fix the unsigned char issue on arm64, ppc64el ans s390x

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Wed, 21 Sep 2022 14:04:04 +0200

cctbx (2022.8+ds2+~3.11.1+ds1-1) unstable; urgency=medium

  * New upstream version 2022.8+ds2+~3.11.1+ds1
  * d/control: Added B-D libann-cctbx-dev
  * d/control: Added B-D libtiff-dev
  * d/control: better short/long description
  * d/control: Added B-D dh-sequence-[numpy|python3]
  * d/p/dxtbx*: import all the dxtbx patches
  * d/rules: built rstbx and dxtbx for dials
  * d/rules: avoid FTBFS when cctbx is already installed
  * d/watch: Added the dxtbx component

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Mon, 19 Sep 2022 15:52:37 +0200

cctbx (2022.8+ds2-1) unstable; urgency=medium

  * d/control: Added B-D python3-pycbf >= 0.9.7+dfsg1-2~
  * d/rules: Added the missing omptbx module
  * d/install-cctbx.sh: Install the annlib_adaptbx at the right place
  * d/t/control: do not run CI on 32bits architectures.
  * New upstream version 2022.8+ds2

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Fri, 02 Sep 2022 10:51:42 +0200

=== debian/control ===
Source: cctbx
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Neil Williams <codehelp@debian.org>,
 Picca Frédéric-Emmanuel <picca@debian.org>,
 Radostan Riedel <raybuntu@googlemail.com>,
Section: science
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 dh-exec,
 dh-python,
 dh-sequence-numpy3,
 dh-sequence-python3,
 jq,
 libann-dev,
 libann-cctbx-dev,
 libantlr3c-dev,
 libboost-dev,
 libboost-numpy-dev,
 libboost-python-dev,
 libboost-thread-dev,
 libcbf-dev (>= 0.9.7+dfsg1-2~),
 libclipper-dev,
 libeigen3-dev,
 libexpat1-dev,
 libfftw3-dev,
 libhdf5-dev,
 liblz4-dev,
 libssm-dev,
 libtiff-dev,
 libtool,
 pybind11-dev,
 python3-all-dev:any,
 python3-biopython,
 python3-future,
 python3-h5py (>= 3) <!nocheck>,
 python3-matplotlib,
 python3-mrcfile,
 python3-msgpack,
 python3-numpy,
 python3-pint,
 python3-pip,
 python3-procrunner,
 python3-psutil,
 python3-pycbf (>= 0.9.7+dfsg1-2~),
 python3-pytest <!nocheck>,
 python3-requests,
 python3-setuptools,
 python3-scipy,
 python3-six,
 python3-tqdm <!nocheck>,
 python3-wxgtk4.0,
 rsync,
 scons,
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/science-team/cctbx
Vcs-Git: https://salsa.debian.org/science-team/cctbx.git
Homepage: https://github.com/cctbx/cctbx_project
Rules-Requires-Root: no

Package: libcctbx0
Architecture: amd64 arm64 armel armhf i386 ppc64 ppc64el riscv64 s390x
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Computational Crystallography Toolbox - runtime libraries
 Computational Crystallography Toolbox contains following modules:
    - annlib_adaptbx:
    - boost_adaptbx: wrappers for Boost functionality in CCTBX
    - cbflib_adaptbx:
    - ccp4io_adaptbx:
    - cctbx: Libraries for general crystallographic applications,
             useful for both small-molecule and macro-molecular
             crystallography.
    - cma_es:
    - crys3d: Modules for the display of molecules, electron density,
              and reciprocal space data.
    - dxtbx: The Diffraction Image Toolbox, a library for handling
             X-ray detector data of arbitrary complexity from a variety
             of standard formats.
    - fable: Fortran EMulation library  for porting Fortran77 to C++.
    - iotbx: Working with common crystallographic file formats.
    - libtbx: The build system common to all other modules. This includes
              a very thin wrapper around the SCons software construction tool.
              It also contains many useful frameworks and utilities to simplify
              application development, including tools for regression testing,
              parallelization across multiprocessor systems and managed clusters,
              and a flexible, modular configuration syntax called PHIL
              (Python Hierarchial Interface Language) used throughout the CCTBX.
    - mmtbx: Functionality specific to macromolecular crystallography.
             This includes all of the machinery required for setup of
             geometry restraints, bulk solvent correction and scaling,
             analysis of macromolecular diffraction data, calculation of
             weighted map coefficients, and most of the methods implemented
             in phenix.refine. The majority of infrastructure for the MolProbity
             validation server (and Phenix equivalent) is also located here.
    - omptbx: OpenMP interface.
    - rstbx: A reciprocal space toolbox to autoindex small molecule Bragg
             diffraction, given the reciprocal space vectors.
    - scitbx: General scientific calculations. his includes a family of
      high-level C++ array types, a fast Fourier transform library,
      and a C++ port of the popular L-BFGS quasi-Newton minimizer.
    - smtbx: Small-Molecule crystallography.
    - spotfinder:
    - tbxx:
    - wxtbx: wxPython controls used in the Phenix GUI and various
        utilities
 .
 This package provide the cctbx runtime libraries.

Package: libcctbx-dev
Architecture: amd64 arm64 armel armhf i386 ppc64 ppc64el riscv64 s390x
Depends:
 libann-cctbx-dev,
 libcctbx0 (= ${binary:Version}),
 ${misc:Depends},
Section: devel
Description: Computational Crystallography Toolbox - headers
 Computational Crystallography Toolbox contains following modules:
    - annlib_adaptbx:
    - boost_adaptbx: wrappers for Boost functionality in CCTBX
    - cbflib_adaptbx:
    - ccp4io_adaptbx:
    - cctbx: Libraries for general crystallographic applications,
             useful for both small-molecule and macro-molecular
             crystallography.
    - cma_es:
    - crys3d: Modules for the display of molecules, electron density,
              and reciprocal space data.
    - dxtbx: The Diffraction Image Toolbox, a library for handling
             X-ray detector data of arbitrary complexity from a variety
             of standard formats.
    - fable: Fortran EMulation library  for porting Fortran77 to C++.
    - iotbx: Working with common crystallographic file formats.
    - libtbx: The build system common to all other modules. This includes
              a very thin wrapper around the SCons software construction tool.
              It also contains many useful frameworks and utilities to simplify
              application development, including tools for regression testing,
              parallelization across multiprocessor systems and managed clusters,
              and a flexible, modular configuration syntax called PHIL
              (Python Hierarchial Interface Language) used throughout the CCTBX.
    - mmtbx: Functionality specific to macromolecular crystallography.
             This includes all of the machinery required for setup of
             geometry restraints, bulk solvent correction and scaling,
             analysis of macromolecular diffraction data, calculation of
             weighted map coefficients, and most of the methods implemented
             in phenix.refine. The majority of infrastructure for the MolProbity
             validation server (and Phenix equivalent) is also located here.
    - omptbx: OpenMP interface.
    - rstbx: A reciprocal space toolbox to autoindex small molecule Bragg
             diffraction, given the reciprocal space vectors.
    - scitbx: General scientific calculations. his includes a family of
      high-level C++ array types, a fast Fourier transform library,
      and a C++ port of the popular L-BFGS quasi-Newton minimizer.
    - smtbx: Small-Molecule crystallography.
    - spotfinder:
    - tbxx:
    - wxtbx: wxPython controls used in the Phenix GUI and various
        utilities
 .
 This package provide everythings needed to link against the cctbx libraries.


Package: python3-cctbx
Architecture: amd64 arm64 armel armhf i386 ppc64 ppc64el riscv64 s390x
Section: python
Depends:
 ca-certificates,
 libcctbx0 (= ${binary:Version}),
 libcctbx-dev (= ${binary:Version}),
 python3-pycbf (>= 0.9.7+dfsg1-2~),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Python Toolbox for crystallography
 Computational Crystallography Toolbox contains following modules:
    - annlib_adaptbx:
    - boost_adaptbx: wrappers for Boost functionality in CCTBX
    - cbflib_adaptbx:
    - ccp4io_adaptbx:
    - cctbx: Libraries for general crystallographic applications,
             useful for both small-molecule and macro-molecular
             crystallography.
    - cma_es:
    - crys3d: Modules for the display of molecules, electron density,
              and reciprocal space data.
    - dxtbx: The Diffraction Image Toolbox, a library for handling
             X-ray detector data of arbitrary complexity from a variety
             of standard formats.
    - fable: Fortran EMulation library  for porting Fortran77 to C++.
    - iotbx: Working with common crystallographic file formats.
    - libtbx: The build system common to all other modules. This includes
              a very thin wrapper around the SCons software construction tool.
              It also contains many useful frameworks and utilities to simplify
              application development, including tools for regression testing,
              parallelization across multiprocessor systems and managed clusters,
              and a flexible, modular configuration syntax called PHIL
              (Python Hierarchial Interface Language) used throughout the CCTBX.
    - mmtbx: Functionality specific to macromolecular crystallography.
             This includes all of the machinery required for setup of
             geometry restraints, bulk solvent correction and scaling,
             analysis of macromolecular diffraction data, calculation of
             weighted map coefficients, and most of the methods implemented
             in phenix.refine. The majority of infrastructure for the MolProbity
             validation server (and Phenix equivalent) is also located here.
    - omptbx: OpenMP interface.
    - rstbx: A reciprocal space toolbox to autoindex small molecule Bragg
             diffraction, given the reciprocal space vectors.
    - scitbx: General scientific calculations. his includes a family of
      high-level C++ array types, a fast Fourier transform library,
      and a C++ port of the popular L-BFGS quasi-Newton minimizer.
    - smtbx: Small-Molecule crystallography.
    - spotfinder:
    - tbxx:
    - wxtbx: wxPython controls used in the Phenix GUI and various
        utilities
 .
 This package provide a selected collection of python modules from the cctbx project.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export DEB_CXXFLAGS_MAINT_APPEND=$(shell pkg-config --cflags hdf5-serial)
export DEB_LDFLAGS_MAINT_APPEND=$(shell pkg-config --libs hdf5-serial)

# parallel support
#NPROC ?= $(shell dh_assistant which-build-system| jq .parallel)
NPROC ?= $(shell nproc)  # for backport

MODULES         = annlib_adaptbx boost_adaptbx cbflib_adaptbx ccp4io_adaptbx cctbx cma_es crys3d dxtbx fable iotbx libtbx mmtbx omptbx rstbx scitbx smtbx spotfinder tbxx wxtbx
MODULES_TODO    = glxtbx
MODULES_FAKE    = annlib ccp4io

# avoid FTBFS when cctbx is already install edon the system (Debian specific)
export HIDE_INSTALLED_CCTBX=1

%:
	dh $@ --buildsystem=pybuild

annlib_adaptbx:
	cp -r debian/annlib_adaptbx annlib_adaptbx
	mkdir annlib

ccp4io_adaptbx:
	cp -r debian/ccp4io_adaptbx ccp4io_adaptbx
	mkdir ccp4io

setup.py : debian/setup.py
	cp -f $< $@

override_dh_auto_clean: setup.py annlib_adaptbx ccp4io_adaptbx
	dh_auto_clean
	find . -name __pycache__ -type d -exec rm -rf {} \;
	rm -f setup.py
	rm -rf annlib annlib_adaptbx
	rm -rf ccp4io ccp4io_adaptbx

override_dh_auto_configure: setup.py annlib_adaptbx ccp4io_adaptbx
	# configure the cctbx python modules
	dh_auto_configure

	# configure dxtbx python modules
	dh_auto_configure --sourcedirectory=dxtbx

	# configure the cctbx libtbx build system
	dh_auto_configure -- -s custom --configure-args="mkdir -p {build_dir}_ && cd {build_dir}_ \
		&& {interpreter} $(CURDIR)/libtbx/configure.py --build=debug --use_environment_flags --enable_cxx11 $(MODULES) $(MODULES_FAKE)"

override_dh_auto_build: setup.py annlib_adaptbx ccp4io_adaptbx
	# build the python modules
	dh_auto_build

	# build the dxtbx python module
	dh_auto_build --sourcedirectory=dxtbx

	# build the cctbx extensions and libraries
	dh_auto_build -- -s custom --build-args="cd {build_dir}_ && ./bin/libtbx.scons -j $(NPROC)"
	iconv -f ISO-8859-1 -t UTF-8 cctbx/eltbx/covalent_radii.h > covalent_radii.h
	mv covalent_radii.h cctbx/eltbx/covalent_radii.h

	# cp all extensions into the python build directory
	# special case for an extension used during test
	dh_auto_build -- -s custom --build-args="cp -f {build_dir}_/lib/*_ext.so {build_dir}_/scitbx/array_family/boost_python/regression_test_ext.so {build_dir}"

	# cp the dxtbx pybind11 extension at the right place.
	dh_auto_build -- -s custom --build-args="cp -f {build_dir}_/lib/dxtbx_flumpy.so {build_dir}"

override_dh_auto_install: setup.py annlib_adaptbx ccp4io_adaptbx
	# install the cctbx python modules
	dh_auto_install

	# install the dxtbx python modules
	dh_auto_install --sourcedirectory=dxtbx

	# specific installation for the cctbx build directory
	dh_auto_install -- -s custom --install-args="debian/install-cctbx.sh -- --pyver={version} --srcdir=$(CURDIR) --builddir={build_dir}_ --modules='$(MODULES)'"

override_dh_link:
	dh_auto_build -- -s custom --build-args="dh_link -p libcctbx-dev usr/include/cctbx usr/lib/cctbx/python{version}/include"

override_dh_auto_test:
	# DOES NOT WORK, source code must be modified in order to find the expected
	# /usr/share/cctbx libtbx_env file during the build process

# target used to trace the embeded git repository used to build cctbx
# a bunche of modules are missing in the original git repository, so embed them for now
embed:
	# annlib_adaptbx
	-git clone http://github.com/cctbx/annlib_adaptbx annlib_adaptbx
	rm -rf annlib_adaptbx/.git*

	# cpp4io_adaptbx
	-git clone http://github.com/cctbx/ccp4io_adaptbx ccp4io_adaptbx
	rm -rf ccp4io_adaptbx/.git*


.PHONY: embed

=== debian/tests/control ===
Test-Command: set -efu
 ; for py in $(py3versions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; echo "Testing cctbx with $py:"
 ; $py /usr/lib/python3/dist-packages/libtbx/command_line/run_tests_parallel.py module=annlib_adaptbx module=boost_adaptbx module=cctbx module=cma_es module=fable module=iotbx module=libtbx module=scitbx module=smtbx module=rstbx module=spotfinder nproc=$(nproc)
# module=cbflib_adaptbx module=glxtbx
 ; done
Depends:
 python3-all,
 python3-cctbx,
 python3-pytest,
Restrictions: allow-stderr, needs-internet, skip-not-installable
Architecture: !armel !armhf !i386

Test-Command: set -efu
 ; for py in $(py3versions -r 2>/dev/null)
 ; do cp -r dxtbx/tests dxtbx/conftest.py "$AUTOPKGTEST_TMP"
 ; cd "$AUTOPKGTEST_TMP"
 ; echo "Testing dxtbx with $py:"
 ; $py -m pytest
 ; done
Depends:
 bitshuffle,
 python3-all,
 python3-cctbx,
 python3-dials-data,
 python3-pytest,
 python3-pytest-mock,
Restrictions: allow-stderr, skip-not-installable
Architecture: !armel !armhf !i386

## cctbx 2023.12+ds2+~3.17.0+ds1

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,13 +3,13 @@
 project(dxtbx LANGUAGES C CXX)
 
 # Add the included modules
-set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")
+set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/")
 
 # General cmake environment configuration
 include(SetDefaultBuildRelWithDebInfo) # Default builds to release with debug info
 include(AlwaysColourCompilation) # Always show coloured compiler output
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON) # Generate compile_commands.json
-set(CMAKE_CXX_STANDARD 11)
+set(CMAKE_CXX_STANDARD 14)
 
 find_package(Python REQUIRED COMPONENTS Interpreter Development)
 find_package(CCTBX COMPONENTS scitbx cctbx REQUIRED)

=== debian/changelog ===
cctbx (2023.12+ds2+~3.17.0+ds1-4build3) noble; urgency=medium

  * No-change rebuild against libccp4c0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 22 Apr 2024 15:31:36 +0000

cctbx (2023.12+ds2+~3.17.0+ds1-4build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 17:46:45 +0000

cctbx (2023.12+ds2+~3.17.0+ds1-4build1) noble; urgency=medium

  * No-change rebuild against libhdf5-103-1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Mar 2024 17:53:36 +0000

cctbx (2023.12+ds2+~3.17.0+ds1-4) unstable; urgency=medium

  * Bug fix: "autopkgtest regression", thanks to Graham Inggs (Closes:
    #1061604).
    - d/t/control: Added g++ in order to have a working c++ compiler for tests.

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Wed, 28 Feb 2024 13:45:40 +0100

cctbx (2023.12+ds2+~3.17.0+ds1-3) unstable; urgency=medium

  * Team upload.

  [ Alexandre Detiste ]
  * python3-future is being removed from Debian (Closes: #1061405)

 -- Andrius Merkys <merkys@debian.org>  Wed, 24 Jan 2024 02:13:56 -0500

cctbx (2023.12+ds2+~3.17.0+ds1-2) unstable; urgency=medium

  * d/control: Added B-D python3-nxmx
  * d/control: Revert orderedset -> ordered-set.
    orderedset is available in Debian, no diversion from upstream.

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Wed, 17 Jan 2024 14:44:58 +0100

cctbx (2023.12+ds2+~3.17.0+ds1-1) unstable; urgency=medium

  [ Bastian Germann ]
  * Add missing autopkgtest dep pytest-regressions

  [ Neil Williams ]
  * Update control to remove myself from Uploaders

  [ Picca Frédéric-Emmanuel ]
  * New upstream version 2023.12+ds2+~3.17.0+ds1
  * d/patches
    - fix the entry_points Python3.12 incompatibility
    - dxtbx use ordered-set instead of orderedset
  * d/t/dxtbx: skip nxmx test fo now
  * d/rules: install the serialtbx module
  * Bug fix: "FTBFS: boost1.83 transition", thanks to
    gladk@debian.org</a>; (Closes: #1056086).
  * Bug fix: "FTBFS with Python 3.12", thanks to Graham Inggs (Closes:
    #1058039).

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Tue, 09 Jan 2024 22:41:16 +0100

cctbx (2022.9+ds2+~3.11.2+ds1-6) unstable; urgency=medium

  * Team upload.
  * Move autopkgtests out into separate script files for maintainability.
  * Move autopkgtest setup out of the loop to support testing on multiple
    supported Python versions. Run the tests in separate directories.
    (Closes: #1027775)
  * Patch: Pickle support for Python 3.11.
  * Patch: Update find_reference_cycles test for Python 3.11.

 -- Stefano Rivera <stefanor@debian.org>  Sun, 08 Jan 2023 10:26:53 -0400

cctbx (2022.9+ds2+~3.11.2+ds1-5) unstable; urgency=medium

  * Team upload.

  [ Picca Frédéric-Emmanuel ]
  * d/control: added B-D python3-pymol

  [ Stefano Rivera ]
  * Patch: setuptools > 60 support (avoid pip breaking setuptools distutils
    magic). (Closes: #1024859)
  * Patch: Use the python3 binary when calling pip.
  * Depend on python3-h5py in the 2nd autopkgtest.

 -- Stefano Rivera <stefanor@debian.org>  Sat, 24 Dec 2022 21:14:52 -0400

cctbx (2022.9+ds2+~3.11.2+ds1-4) unstable; urgency=medium

  * d/rules: remove also the gui_resources in the clean target
    Bug fix: "FTBFS: dpkg-source: error: aborting due to unexpected
    upstream changes, see
    /tmp/cctbx_2022.9+ds2+~3.11.2+ds1-3.diff.lOjzg7", thanks to Lucas
    Nussbaum (Closes: #1022354).

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Tue, 01 Nov 2022 08:54:57 +0100

cctbx (2022.9+ds2+~3.11.2+ds1-3) unstable; urgency=medium

  * build also the gltbx package
    - Added the gui_resources in order to build it
    - activate the gltbx tests
  * d/rules: build only on 64 bit arch
  * d/t/control: add verbosity to the autopkgtests
  * d/control: B-D libgl-dev and libglu1-mesa-dev for the gltbx
  * d/control: Added the gltbx description
  * d/control: Added libboost-python-dev and libccp4-dev to libcctbx-dev

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Wed, 19 Oct 2022 14:36:39 +0200

cctbx (2022.9+ds2+~3.11.2+ds1-2) unstable; urgency=medium

  * d/control: B-D libann-cctbx-dev (>= 1.1.2+doc-9~) and removed libann-dev
  * d/pathes/*: refreshed to compile annlib with the new ANNSELF_EXCLUDE namespace

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Fri, 14 Oct 2022 12:08:38 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: cctbx
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders:
- Neil Williams <codehelp@debian.org>,
  Picca Frédéric-Emmanuel <picca@debian.org>,
  Radostan Riedel <raybuntu@googlemail.com>,
 Section: science
@@ -13,8 +13,7 @@
  dh-sequence-numpy3,
  dh-sequence-python3,
  jq,
- libann-dev,
- libann-cctbx-dev,
+ libann-cctbx-dev (>= 1.1.2+doc-9~),
  libantlr3c-dev,
  libboost-dev,
  libboost-numpy-dev,
@@ -25,6 +24,8 @@
  libeigen3-dev,
  libexpat1-dev,
  libfftw3-dev,
+ libgl-dev,
+ libglu1-mesa-dev,
  libhdf5-dev,
  liblz4-dev,
  libssm-dev,
@@ -33,27 +34,29 @@
  pybind11-dev,
  python3-all-dev:any,
  python3-biopython,
- python3-future,
  python3-h5py (>= 3) <!nocheck>,
  python3-matplotlib,
  python3-mrcfile,
  python3-msgpack,
  python3-numpy,
+ python3-nxmx,
+ python3-orderedset,
  python3-pint,
  python3-pip,
  python3-procrunner,
  python3-psutil,
  python3-pycbf (>= 0.9.7+dfsg1-2~),
+ python3-pymol,
  python3-pytest <!nocheck>,
  python3-requests,
+ python3-scipy,
  python3-setuptools,
- python3-scipy,
  python3-six,
  python3-tqdm <!nocheck>,
  python3-wxgtk4.0,
  rsync,
  scons,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/science-team/cctbx
 Vcs-Git: https://salsa.debian.org/science-team/cctbx.git
 Homepage: https://github.com/cctbx/cctbx_project
@@ -81,6 +84,7 @@
              X-ray detector data of arbitrary complexity from a variety
              of standard formats.
     - fable: Fortran EMulation library  for porting Fortran77 to C++.
+    - gltbx: Python bindings for OpenGL
     - iotbx: Working with common crystallographic file formats.
     - libtbx: The build system common to all other modules. This includes
               a very thin wrapper around the SCons software construction tool.
@@ -114,6 +118,8 @@
 Architecture: amd64 arm64 armel armhf i386 ppc64 ppc64el riscv64 s390x
 Depends:
  libann-cctbx-dev,
+ libboost-python-dev,
+ libccp4-dev,
  libcctbx0 (= ${binary:Version}),
  ${misc:Depends},
 Section: devel
@@ -133,6 +139,7 @@
              X-ray detector data of arbitrary complexity from a variety
              of standard formats.
     - fable: Fortran EMulation library  for porting Fortran77 to C++.
+    - gltbx: Python bindings for OpenGL
     - iotbx: Working with common crystallographic file formats.
     - libtbx: The build system common to all other modules. This includes
               a very thin wrapper around the SCons software construction tool.
@@ -162,14 +169,13 @@
  .
  This package provide everythings needed to link against the cctbx libraries.
 
-
 Package: python3-cctbx
 Architecture: amd64 arm64 armel armhf i386 ppc64 ppc64el riscv64 s390x
 Section: python
 Depends:
  ca-certificates,
+ libcctbx-dev (= ${binary:Version}),
  libcctbx0 (= ${binary:Version}),
- libcctbx-dev (= ${binary:Version}),
  python3-pycbf (>= 0.9.7+dfsg1-2~),
  ${misc:Depends},
  ${python3:Depends},
@@ -190,6 +196,7 @@
              X-ray detector data of arbitrary complexity from a variety
              of standard formats.
     - fable: Fortran EMulation library  for porting Fortran77 to C++.
+    - gltbx: Python bindings for OpenGL
     - iotbx: Working with common crystallographic file formats.
     - libtbx: The build system common to all other modules. This includes
               a very thin wrapper around the SCons software construction tool.

=== debian/rules ===
--- 
+++ 
@@ -10,15 +10,15 @@
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
 
-export DEB_CXXFLAGS_MAINT_APPEND=$(shell pkg-config --cflags hdf5-serial)
+export DEB_CXXFLAGS_MAINT_APPEND := $(shell pkg-config --cflags hdf5-serial) -DBOOST_TIMER_ENABLE_DEPRECATED=1
 export DEB_LDFLAGS_MAINT_APPEND=$(shell pkg-config --libs hdf5-serial)
 
 # parallel support
 #NPROC ?= $(shell dh_assistant which-build-system| jq .parallel)
 NPROC ?= $(shell nproc)  # for backport
 
-MODULES         = annlib_adaptbx boost_adaptbx cbflib_adaptbx ccp4io_adaptbx cctbx cma_es crys3d dxtbx fable iotbx libtbx mmtbx omptbx rstbx scitbx smtbx spotfinder tbxx wxtbx
-MODULES_TODO    = glxtbx
+MODULES         = annlib_adaptbx boost_adaptbx cbflib_adaptbx ccp4io_adaptbx cctbx cma_es crys3d dxtbx fable gltbx iotbx libtbx mmtbx omptbx rstbx scitbx serialtbx smtbx spotfinder tbxx wxtbx
+#MODULES_TODO    = gltbx
 MODULES_FAKE    = annlib ccp4io
 
 # avoid FTBFS when cctbx is already install edon the system (Debian specific)
@@ -35,17 +35,30 @@
 	cp -r debian/ccp4io_adaptbx ccp4io_adaptbx
 	mkdir ccp4io
 
+gui_resources:
+	cp -r debian/gui_resources gui_resources
+
 setup.py : debian/setup.py
 	cp -f $< $@
+	# add missing __init__.py files. It seems that it doesn not work when I use a patch
+	touch serialtbx/__init__.py
+	touch serialtbx/detector/legacy_metrology/__init__.py
+	touch serialtbx/mono_simulation/__init__.py
+	touch serialtbx/util/__init__.py
 
-override_dh_auto_clean: setup.py annlib_adaptbx ccp4io_adaptbx
+override_dh_auto_clean: setup.py annlib_adaptbx ccp4io_adaptbx gui_resources
 	dh_auto_clean
 	find . -name __pycache__ -type d -exec rm -rf {} \;
 	rm -f setup.py
 	rm -rf annlib annlib_adaptbx
 	rm -rf ccp4io ccp4io_adaptbx
+	rm -rf gui_resources
+	rm -f serialtbx/__init__.py
+	rm -f serialtbx/detector/legacy_metrology/__init__.py
+	rm -f serialtbx/mono_simulation/__init__.py
+	rm -f serialtbx/util/__init__.py
 
-override_dh_auto_configure: setup.py annlib_adaptbx ccp4io_adaptbx
+override_dh_auto_configure: setup.py annlib_adaptbx ccp4io_adaptbx gui_resources
 	# configure the cctbx python modules
 	dh_auto_configure
 
@@ -54,9 +67,10 @@
 
 	# configure the cctbx libtbx build system
 	dh_auto_configure -- -s custom --configure-args="mkdir -p {build_dir}_ && cd {build_dir}_ \
-		&& {interpreter} $(CURDIR)/libtbx/configure.py --build=debug --use_environment_flags --enable_cxx11 $(MODULES) $(MODULES_FAKE)"
+		&& {interpreter} $(CURDIR)/libtbx/configure.py --build=debug --use_environment_flags --cxxstd=c++14 $(MODULES) $(MODULES_FAKE)"
 
-override_dh_auto_build: setup.py annlib_adaptbx ccp4io_adaptbx
+override_dh_auto_build: setup.py annlib_adaptbx ccp4io_adaptbx gui_resources
+ifeq ($(shell dpkg-architecture -qDEB_TARGET_ARCH_BITS), 64)
 	# build the python modules
 	dh_auto_build
 
@@ -74,8 +88,11 @@
 
 	# cp the dxtbx pybind11 extension at the right place.
 	dh_auto_build -- -s custom --build-args="cp -f {build_dir}_/lib/dxtbx_flumpy.so {build_dir}"
+else
+	false
+endif
 
-override_dh_auto_install: setup.py annlib_adaptbx ccp4io_adaptbx
+override_dh_auto_install: setup.py annlib_adaptbx ccp4io_adaptbx gui_resources
 	# install the cctbx python modules
 	dh_auto_install
 
@@ -103,5 +120,10 @@
 	-git clone http://github.com/cctbx/ccp4io_adaptbx ccp4io_adaptbx
 	rm -rf ccp4io_adaptbx/.git*
 
+	# gui_resources
+	-git clone http://github.com/cctbx/gui_resources gui_resources
+	rm -rf gui_resources/.git*
+	rm -rf gui_resources/icons
+	rm -rf gui_resources/gl2ps
 
 .PHONY: embed

## cctbx 2024.8+ds2+~3.21.1+ds1

=== debian/changelog ===
cctbx (2024.8+ds2+~3.21.1+ds1-3) unstable; urgency=medium

  * Bug fix: "FTBFS deliberately on 32 bit archs", thanks to Bastian
    Germann (Closes: #1029789).
  * Add myself to Uploaders.

 -- Roland Mas <lolando@debian.org>  Tue, 01 Oct 2024 20:12:32 +0200

cctbx (2024.8+ds2+~3.21.1+ds1-2) unstable; urgency=medium

  * Team upload.
  * Replace orderedset with ordered_set since the former seems no longer
    maintained.

 -- Roland Mas <lolando@debian.org>  Fri, 27 Sep 2024 19:16:24 +0200

cctbx (2024.8+ds2+~3.21.1+ds1-1) unstable; urgency=medium

  * New upstream version 2024.8+ds2+~3.21.1+ds1
  * Bug fix: "autopkgtest failure with Python 3.12 only", thanks to Graham
    Inggs (Closes: #1076084).
  * d/control: B-D added libboost-timer-dev, python3-hdf5plugin, python3-natsort
  * d/p/*:
    - Refreshed for the new version
    - Added 0026-remove-distutils-in-some-modules.patch
  * d/rules: remove workaround since upstream added missing __init__.py files

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Wed, 25 Sep 2024 16:56:44 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: cctbx
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders:
  Picca Frédéric-Emmanuel <picca@debian.org>,
  Radostan Riedel <raybuntu@googlemail.com>,
+ Roland Mas <lolando@debian.org>,
 Section: science
 Priority: optional
 Build-Depends:
+ architecture-is-64-bit,
  debhelper-compat (= 13),
  dh-exec,
  dh-python,
@@ -19,6 +20,7 @@
  libboost-numpy-dev,
  libboost-python-dev,
  libboost-thread-dev,
+ libboost-timer-dev,
  libcbf-dev (>= 0.9.7+dfsg1-2~),
  libclipper-dev,
  libeigen3-dev,
@@ -35,12 +37,14 @@
  python3-all-dev:any,
  python3-biopython,
  python3-h5py (>= 3) <!nocheck>,
+ python3-hdf5plugin,
  python3-matplotlib,
  python3-mrcfile,
  python3-msgpack,
+ python3-natsort,
  python3-numpy,
  python3-nxmx,
- python3-orderedset,
+ python3-ordered-set,
  python3-pint,
  python3-pip,
  python3-procrunner,

=== debian/rules ===
--- 
+++ 
@@ -40,11 +40,6 @@
 
 setup.py : debian/setup.py
 	cp -f $< $@
-	# add missing __init__.py files. It seems that it doesn not work when I use a patch
-	touch serialtbx/__init__.py
-	touch serialtbx/detector/legacy_metrology/__init__.py
-	touch serialtbx/mono_simulation/__init__.py
-	touch serialtbx/util/__init__.py
 
 override_dh_auto_clean: setup.py annlib_adaptbx ccp4io_adaptbx gui_resources
 	dh_auto_clean
@@ -53,10 +48,6 @@
 	rm -rf annlib annlib_adaptbx
 	rm -rf ccp4io ccp4io_adaptbx
 	rm -rf gui_resources
-	rm -f serialtbx/__init__.py
-	rm -f serialtbx/detector/legacy_metrology/__init__.py
-	rm -f serialtbx/mono_simulation/__init__.py
-	rm -f serialtbx/util/__init__.py
 
 override_dh_auto_configure: setup.py annlib_adaptbx ccp4io_adaptbx gui_resources
 	# configure the cctbx python modules
@@ -70,7 +61,6 @@
 		&& {interpreter} $(CURDIR)/libtbx/configure.py --build=debug --use_environment_flags --cxxstd=c++14 $(MODULES) $(MODULES_FAKE)"
 
 override_dh_auto_build: setup.py annlib_adaptbx ccp4io_adaptbx gui_resources
-ifeq ($(shell dpkg-architecture -qDEB_TARGET_ARCH_BITS), 64)
 	# build the python modules
 	dh_auto_build
 
@@ -88,9 +78,6 @@
 
 	# cp the dxtbx pybind11 extension at the right place.
 	dh_auto_build -- -s custom --build-args="cp -f {build_dir}_/lib/dxtbx_flumpy.so {build_dir}"
-else
-	false
-endif
 
 override_dh_auto_install: setup.py annlib_adaptbx ccp4io_adaptbx gui_resources
 	# install the cctbx python modules

## cctbx 2024.10+ds2+~3.22.1+ds1

=== debian/changelog ===
cctbx (2024.10+ds2+~3.22.1+ds1-5build3) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 21 Oct 2025 17:42:04 +0000

cctbx (2024.10+ds2+~3.22.1+ds1-5build2) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 17:13:41 +0200

cctbx (2024.10+ds2+~3.22.1+ds1-5build1) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 17:03:16 +0200

cctbx (2024.10+ds2+~3.22.1+ds1-5) unstable; urgency=medium

  [ Michael R. Crusoe ]
  * Team upload.
  * d/rules: use DEB_BUILD_OPTION_PARALLEL instead of nproc to respect
    Debian Policy 4.9.1.

  [ Roland Mas ]
  * Backport upstream patch to fix: "autopkgtest regression in testing",
    thanks to Graham Inggs (Closes: #1101031).
  * Fix pip invocation to help with autopkgtests.

 -- Roland Mas <lolando@debian.org>  Thu, 29 May 2025 18:19:06 +0200

cctbx (2024.10+ds2+~3.22.1+ds1-4) unstable; urgency=medium

  * Bug fix: "removal of Python standard libraries in Python 3.13", thanks
    to Louis-Philippe Véronneau (Closes: #1084540).

 -- Roland Mas <lolando@debian.org>  Wed, 20 Nov 2024 15:50:35 +0100

cctbx (2024.10+ds2+~3.22.1+ds1-3) unstable; urgency=medium

  * refresh the annlib_adaptor so the test are now ok
  * d/t/control: no more flaky test

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Wed, 20 Nov 2024 09:19:32 +0100

cctbx (2024.10+ds2+~3.22.1+ds1-2) unstable; urgency=medium

  * Mark part of the testsuite as flaky for now.

 -- Roland Mas <lolando@debian.org>  Wed, 13 Nov 2024 14:55:22 +0100

cctbx (2024.10+ds2+~3.22.1+ds1-1) unstable; urgency=medium

  * New upstream release.

 -- Roland Mas <lolando@debian.org>  Wed, 13 Nov 2024 12:16:10 +0100

=== debian/control ===
--- 
+++ 
@@ -35,29 +35,30 @@
  libtool,
  pybind11-dev,
  python3-all-dev:any,
- python3-biopython,
+ python3-biopython <!nocheck>,
  python3-h5py (>= 3) <!nocheck>,
- python3-hdf5plugin,
- python3-matplotlib,
- python3-mrcfile,
- python3-msgpack,
- python3-natsort,
- python3-numpy,
- python3-nxmx,
- python3-ordered-set,
- python3-pint,
- python3-pip,
- python3-procrunner,
- python3-psutil,
- python3-pycbf (>= 0.9.7+dfsg1-2~),
- python3-pymol,
+ python3-hdf5plugin <!nocheck>,
+ python3-legacy-cgi <!nocheck>,
+ python3-matplotlib <!nocheck>,
+ python3-mrcfile <!nocheck>,
+ python3-msgpack <!nocheck>,
+ python3-natsort <!nocheck>,
+ python3-numpy <!nocheck>,
+ python3-nxmx <!nocheck>,
+ python3-ordered-set <!nocheck>,
+ python3-pint <!nocheck>,
+ python3-pip <!nocheck>,
+ python3-procrunner <!nocheck>,
+ python3-psutil <!nocheck>,
+ python3-pycbf (>= 0.9.7+dfsg1-2~) <!nocheck>,
+ python3-pymol <!nocheck>,
  python3-pytest <!nocheck>,
- python3-requests,
- python3-scipy,
+ python3-requests <!nocheck>,
+ python3-scipy <!nocheck>,
  python3-setuptools,
- python3-six,
+ python3-six <!nocheck>,
  python3-tqdm <!nocheck>,
- python3-wxgtk4.0,
+ python3-wxgtk4.0 <!nocheck>,
  rsync,
  scons,
 Standards-Version: 4.6.2
@@ -180,6 +181,7 @@
  ca-certificates,
  libcctbx-dev (= ${binary:Version}),
  libcctbx0 (= ${binary:Version}),
+ python3-legacy-cgi,
  python3-pycbf (>= 0.9.7+dfsg1-2~),
  ${misc:Depends},
  ${python3:Depends},

## cctbx 2025.2%2Bds2%2B~3.23.0%2Bds1

=== src/dxtbx/CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 target_link_libraries( dxtbx_format_nexus_ext PRIVATE  Boost::python CCTBX::scitbx hdf5::hdf5 )
 
 Python_add_library( dxtbx_imageset_ext MODULE boost_python/imageset_ext.cc )
-target_link_libraries( dxtbx_imageset_ext PUBLIC Boost::python CCTBX::scitbx )
+target_link_libraries( dxtbx_imageset_ext PUBLIC Boost::python CCTBX::scitbx CCTBX::scitbx::boost_python )
 
 Python_add_library( dxtbx_format_image_ext
     MODULE
@@ -75,6 +75,13 @@
     target_compile_options(dxtbx_flumpy PRIVATE -fvisibility=hidden)
 endif()
 
+# pybind11 causes a bounds checking warning on recent compilers
+check_cxx_compiler_flag("-Wno-array-bounds" HAS_BOUNDS_WARNING)
+check_cxx_compiler_flag("-Wno-stringop-overread" HAS_OVERREAD_WARNING)
+if(HAS_BOUNDS_WARNING AND HAS_OVERREAD_WARNING)
+    target_compile_options(dxtbx_flumpy PRIVATE -Wno-array-bounds -Wno-stringop-overread)
+endif()
+
 install(
     TARGETS
         dxtbx_ext

=== debian/control ===
--- 
+++ 
@@ -47,7 +47,7 @@
  python3-nxmx <!nocheck>,
  python3-ordered-set <!nocheck>,
  python3-pint <!nocheck>,
- python3-pip <!nocheck>,
+ python3-pip,
  python3-procrunner <!nocheck>,
  python3-psutil <!nocheck>,
  python3-pycbf (>= 0.9.7+dfsg1-2~) <!nocheck>,
@@ -56,7 +56,7 @@
  python3-requests <!nocheck>,
  python3-scipy <!nocheck>,
  python3-setuptools,
- python3-six <!nocheck>,
+ python3-six,
  python3-tqdm <!nocheck>,
  python3-wxgtk4.0 <!nocheck>,
  rsync,
